  /*Odpalamy Bfs jednocześnie ze wszystkich wierchołków, gdzie są domy. 
  Niech v będzie wierzchołkiem. Przez skad[v] oznaczymy najbliższy dom dla v, a przez odl[v] - odleglosc do tego najblizszego domu.
  Kiedy drzewa przeszukiwania wszerz wychodzące z dwóch różnych domów się spotkają, to wypisujemy odległość między tymi domami.
  (czyli dla pewnych sasiadujacych wierzcholkow u, v zajdzie skad[u] != skad[v], wypisujemy wtedy odl[u] + odl[v] + 1)
  */
#include <cstdio>
#include <vector>
#include <queue>
#define MAXN 500000
using namespace std;
int n,m,k;
vector<int> G[MAXN+1];
int vis[MAXN+1],skad[MAXN+1],odl[MAXN+1];
int main()
{
  scanf("%d %d",&n,&m);
  for (int i=0;i<m;i++)
  {
    int x,y;
    scanf("%d %d",&x,&y);
    G[x].push_back(y);
    G[y].push_back(x);
  }
  scanf("%d",&k);
  queue<int> Q;
  for (int i=0;i<k;i++)
  {
    int x;
    scanf("%d",&x);
    Q.push(x);
    skad[x] = x;
    vis[x] = 1;
    odl[x] = 0;
  }
  int x;
  while (!Q.empty())
  {
    x = Q.front();
    Q.pop();
    vis[x] = 2;
    for (int i=0;i<G[x].size();i++)
    {
      if (!vis[G[x][i]])
      {
	vis[G[x][i]] = 1;
	odl[G[x][i]] = odl[x] + 1;
	skad[G[x][i]] = skad[x];
	Q.push(G[x][i]);
      }
      else
      {
	if (skad[x] != skad[G[x][i]])
	{
	  printf("%d\n",odl[x]+odl[G[x][i]]+1);
	  return 0;
	}
      }
    }
  }
  printf("NIE\n");
  return 0;
}