/*Rozwiązanie zadania Godzilla z ONTAKu 2010
Niech w_1, w_2, ... , w_n będą wieżowcami posortowanymi malejąco względem liczby ludzi w środku.
Zauważmy, że dla Godzilli najkorzystniej byłoby pozjadać wszystkie wieżowce w kolejności od najbardziej do najmniej zaludnionych (nie burząc przy tym żadnych dotychczas niezjedzonych). 
Gdyby było to możliwe, tzn struktura grafu by na to pozwalała, to zjadłaby wtedy dokładnie:
    w_1 - 0 + max(0, w_2 - 1) + max(0, w_3 - 2) + ... + max(0, w_n - (n - 1))
(Godzilla w i-tym dniu zjada max(0, w_i - (i - 1)) mieszkańców, bo w wieżowcu nie może znajdować się ujemna liczba ludzi).
Zauważmy, że jeżeli w k-tym dniu Godzilla zjadła 0 mieskzańców, to w następnych dniach też już nikogo nie zje, ponieważ zawsze zjada ludzi z najbardziej zaludnionego domu.
Weźmy najmniejsze takie k (jeśli nie istnieje, to przyjmijmy k = n + 1)
Wtedy Godzilla zje S = (w_1 - 0) + (w_2 - 1) + (w_3 - 2) + ... + (w_(k - 1) - (k - 2)) = w_1 + w_2 + ... + w_(k-1) + (k - 2) * (k - 1) / 2
Jednak nie zawsze struktura grafu pozwala na zjadanie wieżowców od najbardziej do najmniej zaludnionych bez burzenia niezjedzonych po drodze. Na szczęście suma S jest niezależna od kolejności zjadania wieżowców. Dlatego optymalne postępowanie dla Godzilli wygląda następująco:
1. Znajduje wspomniane k.
2. Postanawia zjeść wieżowce w_1, w_2, ..., w_(k - 1)
3. Zjada je w takiej kolejności, aby nie niszczyć nigdy wieżowca, który zamierza zjeść, a jeszcze go nie zjadła. (Zawsze da się to zrobić, więc nie trzeba nawet wczytywać struktury grafu)
4. Godzilla zje wtedy S ludzi.
*/

#include <cstdio>
#include <algorithm>
#ifdef DEBUG
	#define DEB printf
#else
	#define DEB(...)
#endif
#define REP(x, n) for(int x = 0; x < (n); x++)
#define FOR(x, b, e) for(int x = (b); x <= (e); x++)
#define N 100000
typedef long long LL;
 using namespace std;
 LL n, m, res, odj;
 LL tab[N];

 struct comp {
	bool operator()(int a, int b) {return a > b;}
 };
 

 int main() {
	 scanf("%lld%lld", &n, &m);
	 REP(i, n) scanf("%lld", &tab[i]);
	 sort(tab, tab + n, comp());
	 REP(i, n) {
		 if((tab[i] - odj) <= 0) break;
		 res += tab[i] - odj;
		 odj++;
	 }
	 printf("%lld", res);
	 return 0;
 }


