/*Rozwiązanie zadania wyd z ONTAKu 2010
Zadaniem Bajtazara jest znaleźć takie i, j, że liczba
a_i + a_(i + 1) + ... + a_(j - 1) + a_j mod m
jest jak największa.
Skorzystamy z pomocniczej tablicy t[0...n] 
t[i] = a_1 + a_2 + ... + a_i mod m
przy czym t[0] = 0
Możemy ją oczywiście policzyć w czsie liniowym, gdyż t[i+1] = t[i] + a_(i+1) mod m
wtedy
a_i + a_(i + 1) + ... + a_(j - 1) + a_j mod m = (t[j] - t[i - 1] mod m
Jeżeli Bajtazar skończy okres rozliczeniowy na j-tym dniu, to najkorzystniej zacząć go od takiego i-tego dnia (i <= j), że 
t[j] - t[i - 1] mod m jest maksymalne. Zawsze może zacząć od 1-go dnia, i wtedy dostanie dokładnie t[j] pieniędzy. 
Spośród takich i <= j, że t[i-1] > t[j], Bajtazar powinien wybrać to i, dla którego t[i-1] jest najmniejsze. Otrzyma wtedy
t[j] - t[i - 1] mod m = m + t[j] - t[i - 1] pieniędzy
takie t[i-1] można znaleźć korzystając z funkcji set.upper_bound()
Wynikiem jest maksimum z wyników dla wszystkich możliwych końców okresu j.
*/

#include <cstdio>
#include <set>
#define N 200001
#define MAX(a, b) (a) > (b) ? (a) : (b)
#define REP(x, n) for(int x = 0; x < (n); x++)
#define FOR(x, b, e) for(int x = (b); x <= (e); x++)
#define LL long long
 
 using namespace std;

 int n;
 LL d, m, tab[N], mx = 0, h;
 set<LL> st;

 LL mod (LL x) {
	 x %= m;
	 if (x < 0) return x + m;
	 return x;
 }

 int main() {
	 scanf("%d%lld", &n, &m);
	 tab[0] = 0;
	 FOR(i, 1, n) {
		 scanf("%lld", &d);
		 tab[i] = mod(tab[i - 1] + d);
	 }
	 st.insert(0);
	 FOR(i, 1, n) {
		if (st.upper_bound(tab[i]) == st.end()) {
			h = tab[i];
		}
		else {
			h = mod(tab[i] - *(st.upper_bound(tab[i])));
		}
		st.insert(tab[i]);
		mx = MAX(mx, h);
	 }
	 printf("%lld", mx);
	 return 0;
 }
